"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _jquery = _interopRequireDefault(require("jquery"));

var Backbone = _interopRequireWildcard(require("backbone"));

var _backboneEvents = _interopRequireDefault(require("../utils/backbone-events"));

var _emaexprTpl = _interopRequireDefault(require("../templates/emaexpr-tpl"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var EMAExprComponent = /*#__PURE__*/function (_Backbone$View) {
  _inherits(EMAExprComponent, _Backbone$View);

  var _super = _createSuper(EMAExprComponent);

  function EMAExprComponent() {
    _classCallCheck(this, EMAExprComponent);

    return _super.apply(this, arguments);
  }

  _createClass(EMAExprComponent, [{
    key: "className",
    get: function get() {
      return "cnt-emabox";
    }
  }, {
    key: "events",
    get: function get() {
      var _this = this;

      return {
        "click .cnt-emabox-x": function clickCntEmaboxX() {
          _this.trigger("component:emaBox:clear");
        },
        "click .cnt-emabox-cp": this.copyExpr,
        "click .cnt-emabox-hide": this.toggle
      };
    }
  }, {
    key: "template",
    value: function template(tpl) {
      return (0, _emaexprTpl["default"])(tpl);
    }
  }, {
    key: "initialize",
    value: function initialize() {
      var _this2 = this;

      this.on('component:emaBox', this.updateEmaBox);
      this.on("component:emaBox:url", function (u) {
        _this2.MEIurl = u;
      });
    }
  }, {
    key: "copyExpr",
    value: function copyExpr(e) {
      e.preventDefault();
      var url = "/" + encodeURIComponent(this.MEIurl) + "/" + this.expr;
      window.prompt("Copy to clipboard: Ctrl+C, Enter", url);
    }
  }, {
    key: "toggle",
    value: function toggle(e) {
      e.preventDefault();

      if (this.$el.hasClass("cnt-hidden")) {
        this.$el.removeClass("cnt-hidden");
      } else {
        this.$el.addClass("cnt-hidden");
      }
    }
  }, {
    key: "updateEmaBox",
    value: function updateEmaBox(expr) {
      this.$el.show();
      this.expr = expr; // let server = "http://localhost:5000";

      var server = "http://mith.umd.edu/ema";
      var loc = window.location.origin + window.location.pathname;
      var tpl_data = {
        "expr": expr,
        "url": loc + "#" + server + "/" + encodeURIComponent(this.MEIurl) + "/" + this.expr + "/highlight"
      };
      this.$el.html(this.template(tpl_data));
      this.delegateEvents(this.events);

      if (expr == "") {
        this.$el.hide();
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.$el;
    }
  }]);

  return EMAExprComponent;
}(Backbone.View);

var _default = EMAExprComponent;
exports["default"] = _default;