"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _jquery = _interopRequireDefault(require("jquery"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var SVGProc = {};

SVGProc.makeSVGEl = function (tag, attrs) {
  var el = document.createElementNS('http://www.w3.org/2000/svg', tag);

  for (var k in attrs) {
    el.setAttribute(k, attrs[k]);
  }

  return el;
};

SVGProc.getSVGCoordinates = function (coords, svg) {
  var pt = svg.createSVGPoint();
  pt.x = coords.x;
  pt.y = coords.y;
  return pt.matrixTransform(svg.getScreenCTM().inverse());
};

SVGProc.getSVGRoot = function (el) {
  var root_el = el;

  if (root_el.tagName != 'svg') {
    root_el = (0, _jquery["default"])(root_el).parents('svg').last().get(0);
  }

  return root_el;
};

var _default = SVGProc;
exports["default"] = _default;